//+---------------------------------------------------------------------+
//|                                                            XVSI.mq5 | 
//|                                         Copyright  2005, DriverDan |
//|                                           superfunman2000@yahoo.com |
//+---------------------------------------------------------------------+
//|          SmoothAlgorithms.mqh |
//|   (): MetaTrader\\MQL5\Include                      |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2005, DriverDan"
#property link "superfunman2000@yahoo.com/"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----   
#property indicator_buffers 2 
//----     
#property indicator_plots   2
//+-----------------------------------+
//|     1 |
//+-----------------------------------+
//----     
#property indicator_type1   DRAW_LINE
//----        
#property indicator_color1 Red
//----   - -
#property indicator_style1  STYLE_DASHDOTDOT
//----     1
#property indicator_width1  1
//----   
#property indicator_label1  "XVSI"
//+-----------------------------------+
//|     2 |
//+-----------------------------------+
//----     
#property indicator_type2   DRAW_LINE
//----        
#property indicator_color2 Blue
//----   -  
#property indicator_style2  STYLE_SOLID
//----     1
#property indicator_width2  1
//----   
#property indicator_label2  "Signal XVSI"
//+-----------------------------------+
//|    CXMA             |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+
//----    CXMA   SmoothAlgorithms.mqh
CXMA XMA;
//+-----------------------------------+
//|             |
//+-----------------------------------+
/*enum Smooth_Method -    SmoothAlgorithms.mqh
  {
   MODE_SMA_,  // SMA
   MODE_EMA_,  // EMA
   MODE_SMMA_, // SMMA
   MODE_LWMA_, // LWMA
   MODE_JJMA,  // JJMA
   MODE_JurX,  // JurX
   MODE_ParMA, // ParMA
   MODE_T3,    // T3
   MODE_VIDYA, // VIDYA
   MODE_AMA,   // AMA
  }; */
//+-----------------------------------+
//|         |
//+-----------------------------------+
input Smooth_Method DSmoothMethod=MODE_T3;         //   
input int DPeriod=15;                              //  
input int DPhase=15;                               //  ,
input ENUM_APPLIED_VOLUME VolumeType=VOLUME_TICK;  // 
input int Shift=0;                                 //      

//----   ,    
//----      
double vsiBuffer[],vsiMABuffer[];
//----      
int StartBars;
//+------------------------------------------------------------------+   
//| XVSI indicator initialization function                           | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//----     
   StartBars=XMA.GetStartBars(DSmoothMethod,DPeriod,DPhase)+1;
//----       
   XMA.XMALengthCheck("DPeriod",DPeriod);
//----       
   XMA.XMAPhaseCheck("DPhase",DPhase,DSmoothMethod);

//----    vsiBuffer[]   
   SetIndexBuffer(0,vsiBuffer,INDICATOR_DATA);
//----    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,StartBars);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----    vsiMABuffer[]   
   SetIndexBuffer(1,vsiMABuffer,INDICATOR_DATA);
//----    1  
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,StartBars);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----      
   string shortname,Smooth;
   Smooth=XMA.GetString_MA_Method(DSmoothMethod);
   StringConcatenate(shortname,"XVSI(",string(DPeriod),",",Smooth,")");
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);

//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----  
  }
//+------------------------------------------------------------------+ 
//| XVSI iteration function                                          | 
//+------------------------------------------------------------------+ 
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(rates_total<StartBars) return(0);
//----       
   double vol;
//----   
   int first,bar,timeDiff;
//----    first       
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=1;                                           //      
     }
   else first=prev_calculated-1;                         //      
//----    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      if(VolumeType==VOLUME_TICK) vol=double(tick_volume[bar]);
      else                        vol=double(volume[bar]);

      if(bar==rates_total-1)
        {
         timeDiff=int(TimeCurrent()-time[bar]);
         if(timeDiff>0) vsiBuffer[bar]=vol/timeDiff;
        }
      else vsiBuffer[bar]=vol/(time[bar]-time[bar-1]);

      vsiMABuffer[bar]=XMA.XMASeries(1,prev_calculated,rates_total,DSmoothMethod,DPhase,DPeriod,vsiBuffer[bar],bar,false);
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
